﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Security.Cryptography;
using System.Text;
using System.Threading.Tasks;
using static System.Net.Mime.MediaTypeNames;

namespace Hangman
{
    internal class Game
    {
        List<char> guessed = new List<char>();
        List<Char> wrongs = new List<Char>();

        HangSprites spr = new HangSprites();

        int attempts = 0;

        public Game(String selectedWord)
        {
            //game loop(TM)
            while (true)
            {
                drawScreen(selectedWord);
                guessLetter(selectedWord);
            }
        }

        public void guessLetter(String word)
        {
            //get guessed char
            ConsoleKeyInfo letter = Console.ReadKey();
            char guessedChar = char.ToLower(letter.KeyChar);

            //make sure the input is a letter
            if (!char.IsLetter(guessedChar))
            {
                return;
            }

            //if already in guessed list, return
            if (guessed.Contains(guessedChar))
            {
                return;
            }

            //add to guessed list
            guessed.Add(guessedChar);
            attempts++;

            //check if all correct chars are guessed
            int correct = 0;
            for (int i = 0; i < guessed.Count; i++)
            {
                if (word.Contains(guessed[i]))
                {
                    correct++;
                }
            }

            //Console.WriteLine(wrongs.Count + " : " + spr.sprites.Count()); //TEMP

            //win or lose or nothing
            if (correct == word.Length)
            {
                winGame();
            }
            else if (wrongs.Count >= spr.sprites.Count())
            {
                loseGame(word);
            }
        }

        public void drawScreen(String word)
        {
            Console.Clear();

            //draw underscores
            for (int i = 0; i < word.Length; i++)
            {
                if (guessed.Contains(word[i]))
                {
                    Console.Write(word[i] + " ");
                }
                else
                {
                    Console.Write("_ ");
                }
            }

            //get wrong guesses
            wrongs = new List<char>();
            for (int i = 0; i < guessed.Count; i++)
            {
                if (!word.Contains(guessed[i]))
                {
                    wrongs.Add(guessed[i]);
                }
            }

            //draw game screen
            Console.Write("\r\n\r\n");
            Console.WriteLine(spr.sprites[wrongs.Count]);
            Console.Write("\r\n\r\n");

            Console.Write("Wrong guesses: ");
            foreach (Char c in wrongs)
                Console.Write(c + ", ");

            Console.WriteLine();
            Console.WriteLine("Attempts: " + attempts);

            Console.Write("Press a key to guess: ");
        }

        void winGame()
        {
            Console.Clear();

            Console.WriteLine("Congrats! You won the game in " + attempts + " attempts");

            //draw game screen
            Console.WriteLine();
            Console.WriteLine(spr.sprites[2]);
            Console.Write("\r\n\r\n");

            Console.WriteLine("Press any key to exit");

            Console.ReadLine();
            Environment.Exit(0);
        }

        void loseGame(String word)
        {
            Console.Clear();

            Console.WriteLine("Boo-hoo! You lost the game! The word was " + word);

            //draw game screen
            Console.WriteLine();
            Console.WriteLine(spr.sprites[spr.sprites.Count() - 1]);
            Console.Write("\r\n\r\n");

            Console.WriteLine("Press any key to exit");

            Console.ReadLine();
            Environment.Exit(0);
        }
    }
}
