﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using Hangman.Dejvoss;
using Microsoft.Data.Sqlite;

namespace Hangman
{
    internal class Program
    {
        static void Main(string[] args)
        {
            Console.Title = "Hangman! v0.1 | (c) DEJVOSS Productions";
            Console.WriteLine("Hangman! v0.1");

            HangSprites sprites = new HangSprites();

            Console.WriteLine("");
            Console.WriteLine("");
            Console.WriteLine(sprites.sprites[sprites.sprites.Count() - 1]);
            Console.WriteLine("");
            Console.WriteLine("");
            Console.WriteLine("Type \'1\' to load words from a .txt");
            Console.WriteLine("or type \'2\' to load words from a database (not working)");



            Console.Write("> ");
            String selection = Console.ReadLine();

            if (selection == "1")
            {
                loadTxt();
            }
            else if (selection == "2")
            {
                loadDb();
            }
            else
            {
                Console.Clear();
                Main(args);
            }
        }

        //load words from txt
        public static void loadTxt()
        {
            String loaded = File.ReadAllText("data.txt");

            String[] loadArr = loaded.Split(new string[] { "\r\n" }, StringSplitOptions.None);
            List<String> words = loadArr.ToList();

            startGame(words);
        }

        //load words from database
        public static void loadDb()
        {
            Database db = new Database("data.db");
            List<String> words = db.readFromTable("*", "words");

            startGame(words);
        }

        //select word and start game
        public static void startGame(List<String> words)
        {
            Random rnd = new Random();
            int next = rnd.Next(0, words.Count);

            Game game = new Game(words[next]);
        }
    }
}
